<?php
#[AllowDynamicProperties]
class MY_Hooks extends CI_Hooks{

 protected function _call_single_hook($data, $params) {
        if($params) {
            if(!isset($data['params'])) {
                $data['params'] = [];
            }
            $data['params'] =  $params;
        }

        $this->_run_hook($data);
        return TRUE;
    }

    /**
     * Call Hook
     *
     * Calls a particular hook. Called by CodeIgniter.php.
     *
     * @uses    CI_Hooks::_run_hook()
     *
     * @param   string  $which  Hook name
     * @param   array   $params  Extra (dynamic) parameters array
     * @return  bool    TRUE on success or FALSE on failure
     */
    public function call_hook($which = '', $params=null)
    {
        if ( ! $this->enabled OR ! isset($this->hooks[$which]))
        {
            return FALSE;
        }
        if (is_array($this->hooks[$which]) && ! isset($this->hooks[$which]['function']))
        {
            foreach ($this->hooks[$which] as $val)
            {
                $this->_call_single_hook($val, $params);
            }
        }
        else
        {
            $this->_call_single_hook($this->hooks[$which], $params);
        }

        return TRUE;
    }
}

?>
